## openshadinglanguage 1.10.9-thomas~bionic9+9.0trisquel1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.2.2)
cmake_policy (SET CMP0048 NEW)  # Allow VERSION specifier in project()
project (OSL
         VERSION 1.10.9
         LANGUAGES CXX C)
set (PROJ_NAME ${PROJECT_NAME})    # short name
string (TOLOWER ${PROJ_NAME} PROJ_NAME_LOWER)  # short name lower case
set (PROJECT_VERSION_RELEASE_TYPE "")   # "dev", "betaX", "RCY", ""
set (${PROJECT_NAME}_VERSION_RELEASE_TYPE ${PROJECT_VERSION_RELEASE_TYPE})
set (PROJECT_COPYRIGHTYEARS "2008-2019")
set (PROJECT_AUTHORS "Sony Pictures Imageworks, et al")
set (PROJECT_URL "")

set (PROJECT_VERSION_MAJORMINOR
     "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
message (STATUS "Building ${PROJECT_NAME} ${PROJECT_VERSION}")
message (STATUS "CMake version is ${CMAKE_VERSION}")
cmake_policy (SET CMP0017 NEW)  # Prefer files from the CMake module directory when including from there.
cmake_policy (SET CMP0025 NEW)  # Detect AppleClang for new CMake
cmake_policy (SET CMP0046 OLD)  # Don't error on non-existent dependency in add_dependencies.
set (CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

# Deprecated names
set (OSL_LIBRARY_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set (OSL_LIBRARY_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set (OSL_LIBRARY_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set (OSL_LIBRARY_VERSION_RELEASE_TYPE ${PROJECT_VERSION_RELEASE_TYPE})

# Version of the OSO file format and instruction set
set (OSO_FILE_VERSION_MAJOR 1)
set (OSO_FILE_VERSION_MINOR 0)

if (VERBOSE)
    message (STATUS "Project source dir = ${PROJECT_SOURCE_DIR}")
endif ()
message (STATUS "Project build dir   = ${CMAKE_BINARY_DIR}")
message (STATUS "Project install dir = ${CMAKE_INSTALL_PREFIX}")

if ("${PROJECT_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message (FATAL_ERROR "Not allowed to run in-source build!")
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "Release")
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set (DEBUGMODE ON)
endif ()

option (CMAKE_USE_FOLDERS "Use the FOLDER target property to organize targets into folders." ON)
mark_as_advanced (CMAKE_USE_FOLDERS)
if (CMAKE_USE_FOLDERS)
    set_property (GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

include (GNUInstallDirs)

list (APPEND CMAKE_MODULE_PATH
      "${PROJECT_SOURCE_DIR}/src/cmake/modules"
      "${PROJECT_SOURCE_DIR}/src/cmake")

include (platform)
include (compiler)   # All the C++ and compiler related options live here


## enable RTTI
##   NOTE: LLVM builds without RTTI by default so beware
##   if you find the need to turn this on, to use OSL in a
##   project that requires RTTI for example, you need to build
##   LLVM with RRTI, otherwise OSL classes extending LLVM ones
##   will cause linker errors.
set (ENABLERTTI OFF CACHE BOOL "Build with RTTI. Requires a LLVM build with RTTI enabled.")
if (NOT ENABLERTTI)
    if (MSVC)
        set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-" )
    else ()
        set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti" )
    endif()
endif()


option (VERBOSE "Print lots of messages while compiling" OFF)
set (${PROJ_NAME}_NAMESPACE ${PROJECT_NAME} CACHE STRING "Customized outer namespace base name (version will be added)")
set (SOVERSION ${OSL_VERSION_MAJOR}.${OSL_VERSION_MINOR}
     CACHE STRING "Set the SO version in the SO name of the output library")
option (OSL_BUILD_TESTS "Build the unit tests, testshade, testrender" ON)
if (WIN32)
    option (USE_LLVM_BITCODE "Generate embedded LLVM bitcode" OFF)
else ()
    option (USE_LLVM_BITCODE "Generate embedded LLVM bitcode" ON)
endif ()
option (USE_PARTIO "Use Partio if found" ON)
set (PARTIO_HOME "" CACHE STRING "Search path for Partio components")
set (PUGIXML_HOME "" CACHE STRING "Hint about where to find external PugiXML library")
option (USE_FAST_MATH "Use fast math approximations (if no, then use system math library)" ON)
option (OSL_BUILD_PLUGINS "Bool OSL plugins, for example OIIO plugin" ON)
option (OSL_BUILD_SHADERS "Build shaders" ON)
option (OSL_BUILD_MATERIALX "Build MaterialX shaders" ON)
option (USE_BOOST_WAVE "Use Boost Wave for C preprocessor (alternative is to use clang)" OFF)
option (USE_QT "Include Qt support" ON)
option (USE_OPTIX "Include OptiX support" OFF)
set (OPTIX_EXTRA_LIBS CACHE STRING "Extra lib targets needed for OptiX")
set (CUDA_TARGET_ARCH "sm_35" CACHE STRING "CUDA GPU architecture (e.g. sm_35)")

# set (USE_OIIO_STATIC ON CACHE BOOL "If OIIO is built static")
# if (USE_OIIO_STATIC)
#     add_definitions ("-DOIIO_STATIC_BUILD=1")
# endif ()

set (OSL_NO_DEFAULT_TEXTURESYSTEM OFF CACHE BOOL "Do not use create a raw OIIO::TextureSystem")
if (OSL_NO_DEFAULT_TEXTURESYSTEM)
    add_definitions ("-DOSL_NO_DEFAULT_TEXTURESYSTEM=1")
endif ()

if (USE_FAST_MATH)
    add_definitions ("-DOSL_FAST_MATH=1")
else ()
    add_definitions ("-DOSL_FAST_MATH=0")
endif ()


# Set the default namespace. For symbol hiding reasons, it's important that
# the project name is a subset of the namespace name.
set (PROJ_NAMESPACE "${${PROJ_NAME}_NAMESPACE}")
string(REGEX MATCH ${PROJECT_NAME} NAMESPACE_HAS_PROJECT_NAME ${PROJ_NAMESPACE})
if (NOT NAMESPACE_HAS_PROJECT_NAME)
    set (PROJ_NAMESPACE ${PROJECT_NAME}_${PROJ_NAMESPACE})
endif ()
set (PROJ_NAMESPACE_V "${PROJ_NAMESPACE}_v${PROJECT_VERSION_MAJOR}_${PROJECT_VERSION_MINOR}")
message(STATUS "Setting Namespace to: ${PROJ_NAMESPACE_V}")

include (util_macros)
include (externalpackages)
include (flexbison)
include (install)          # installation options all implemented here

include_directories (
    BEFORE
    "${CMAKE_SOURCE_DIR}/src/include"
    "${CMAKE_BINARY_DIR}/include"
  )




###########################################################################


# We want CTest for testing
# N.B. This needs to be added before any of the subdirectories, or
# their add_test commands will not register.
include (CTest)


# Tell CMake to process the sub-directories
add_subdirectory (src/include)
add_subdirectory (src/liboslcomp)
add_subdirectory (src/liboslquery)
add_subdirectory (src/liboslexec)
add_subdirectory (src/liboslnoise)

add_subdirectory (src/oslc)
add_subdirectory (src/oslinfo)

if (OSL_BUILD_TESTS)
add_subdirectory (src/testshade)
add_subdirectory (src/testrender)
endif ()

if (OSL_BUILD_TESTS AND USE_OPTIX)
add_subdirectory (src/testoptix)
endif()

if (OSL_BUILD_PLUGINS)
add_subdirectory (src/osl.imageio)
endif ()

if (USE_QT AND Qt5_FOUND)
add_subdirectory (src/osltoy)
endif ()

if (OSL_BUILD_SHADERS)
    add_subdirectory (src/shaders)
    if (OSL_BUILD_MATERIALX)
      add_subdirectory (src/shaders/MaterialX)
    endif ()
endif ()

if (INSTALL_DOCS)
add_subdirectory (src/doc)
endif ()

# Oddball: install the FindOSL.cmake file
# install (FILES src/cmake/modules/FindOSL.cmake
#          DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/cmake/Modules
#          COMPONENT cmake)



#########################################################################
# Testing

# Make a build/platform/testsuite directory, and copy the master runtest.py
# there. The rest is up to the tests themselves.
file (MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/testsuite")
add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/testsuite/runtest.py"
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different
                        "${CMAKE_SOURCE_DIR}/testsuite/runtest.py"
                        "${CMAKE_BINARY_DIR}/testsuite/runtest.py"
                    MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/testsuite/runtest.py")
add_custom_target ( CopyFiles ALL DEPENDS "${CMAKE_BINARY_DIR}/testsuite/runtest.py" )

macro ( TESTSUITE )
    cmake_parse_arguments (_ats "" "LABEL" "" ${ARGN})
    # If there was a FOUNDVAR param specified and that variable name is
    # not defined, mark the test as broken.
    if (_ats_FOUNDVAR AND NOT ${_ats_FOUNDVAR})
        set (_ats_LABEL "broken")
    endif ()
    # Add the tests if all is well.
    set (ALL_TEST_LIST "")
    foreach (_testname ${_ats_UNPARSED_ARGUMENTS})
        set (_testsrcdir "${CMAKE_SOURCE_DIR}/testsuite/${_testname}")
        set (_testdir "${CMAKE_BINARY_DIR}/testsuite/${_testname}")
        if (_ats_LABEL MATCHES "broken")
            set (_testname "${_testname}-broken")
        endif ()
        set (_runtest python "${CMAKE_BINARY_DIR}/testsuite/runtest.py"
                             ${_testdir} ${_extra_test_args})
        if (MSVC_IDE)
            set (_runtest ${_runtest} --devenv-config $<CONFIGURATION>
                                      --solution-path "${CMAKE_BINARY_DIR}" )
        endif ()

        file (MAKE_DIRECTORY "${_testdir}")

        # Run the test unoptimized, unless it's a "render_*" or "oslinfo_*"
        # test, which we don't bother testing unoptimized.
        if (NOT _testname MATCHES "^render" AND
            NOT _testname MATCHES "^oslinfo" AND
            NOT _testname MATCHES "^getattribute-shader" AND
            NOT EXISTS "${_testsrcdir}/OPTIMIZEONLY")
          set (_env TESTSHADE_OPT=0 OPENIMAGEIO_ROOT_DIR=${OPENIMAGEIO_ROOT_DIR})
          add_test ( NAME ${_testname}
                     COMMAND env ${_env} ${_runtest} )
        endif ()
        # Run the same test again with aggressive -O2 runtime
        # optimization, triggered by setting TESTSHADE_OPT env variable
        set (_env TESTSHADE_OPT=2 OPENIMAGEIO_ROOT_DIR=${OPENIMAGEIO_ROOT_DIR})
        set (ALL_TEST_LIST "${ALL_TEST_LIST} ${_testname}")
        add_test ( NAME ${_testname}.opt
                   COMMAND env ${_env} ${_runtest} )
    endforeach ()
    if (VERBOSE)
        message (STATUS "Added tests: ${ALL_TEST_LIST}")
    endif ()
endmacro ()

if (OSL_BUILD_TESTS)
# List all the individual testsuite tests here, except those that need
# special installed tests.
TESTSUITE ( aastep allowconnect-err and-or-not-synonyms arithmetic
            array array-derivs array-range array-aassign
            blackbody blendmath breakcont
            bug-array-heapoffsets bug-locallifetime bug-outputinit
            bug-param-duplicate bug-peep bug-return
            cellnoise closure closure-array color comparison
            compile-buffer
            component-range
            connect-components
            const-array-params const-array-fill
            debugnan debug-uninit
            derivs derivs-muldiv-clobber
            draw_string
            error-dupes exit exponential
            fprintf
            function-earlyreturn function-simple function-outputelem
            function-overloads function-redef
            geomath getattribute-camera getattribute-shader
            getsymbol-nonheap gettextureinfo
            group-outputs groupstring
            hash hashnoise hex hyperb
            ieee_fp if incdec initlist initops intbits isconnected isconstant
            layers layers-Ciassign layers-entry layers-lazy
            layers-nonlazycopy layers-repeatedoutputs
            linearstep
            logic loop matrix message
            mergeinstances-duplicate-entrylayers
            mergeinstances-nouserdata mergeinstances-vararray
            metadata-braces miscmath missing-shader
            noise noise-cell
            noise-gabor noise-gabor2d-filter noise-gabor3d-filter
            noise-perlin noise-simplex
            pnoise pnoise-cell pnoise-gabor pnoise-perlin
            operator-overloading
            oslc-comma oslc-D
            oslc-err-arrayindex oslc-err-assignmenttypes
            oslc-err-closuremul oslc-err-field
            oslc-err-format oslc-err-funcoverload
            oslc-err-intoverflow oslc-err-write-nonoutput
            oslc-err-noreturn oslc-err-notfunc
            oslc-err-initlist-args oslc-err-initlist-return
            oslc-err-outputparamvararray oslc-err-paramdefault
            oslc-err-struct-array-init oslc-err-struct-ctr
            oslc-err-struct-dup oslc-err-struct-print
            oslc-err-unknown-ctr
            oslc-warn-commainit
            oslc-variadic-macro
            oslc-version
            oslinfo-arrayparams oslinfo-colorctrfloat
            oslinfo-metadata oslinfo-noparams

=== src/doc/CMakeLists.txt ===
set (public_docs osl-languagespec.pdf
                 testshade.md.html
                 osltoy.md.html
                 markdeep.min.js
                 docs.css
                 )

install (FILES ${public_docs} DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)

install ( FILES "${PROJECT_SOURCE_DIR}/LICENSE"
                "${PROJECT_SOURCE_DIR}/INSTALL.md"
                "${PROJECT_SOURCE_DIR}/CHANGES.md"
                "${PROJECT_SOURCE_DIR}/README.md"
          DESTINATION ${CMAKE_INSTALL_DOCDIR} )


file (GLOB testshade_figures "Figures/testshade/*.jpg")
install (FILES ${testshade_figures}
         DESTINATION ${CMAKE_INSTALL_DOCDIR}/Figures/testshade )

file (GLOB osltoy_figures "Figures/osltoy/*.jpg")
install (FILES ${osltoy_figures}
         DESTINATION ${CMAKE_INSTALL_DOCDIR}/Figures/osltoy )



# Macro to compile a shader with oslc. Syntax is:
#   docdeep_generate (SOURCE osl_source_file
#                 [ NAME doc_name ]
#                 [ DOC_LIST list_to_append_doc_filename ] )
#                 [ SRC_LIST list_to_append_src_filename ] )
macro (docdeep_generate)
    cmake_parse_arguments (_docdeep "" "NAME;DOC_LIST;SRC_LIST" "SOURCE" ${ARGN})
    # ^^ syntax: prefix options one-arg-keywords multi-arg-keywords args
    set (oslfile ${_docdeep_SOURCE})
    set (mdfile "${_docdeep_NAME}.md.html")
    if (VERBOSE)
        message (STATUS "docdeep will make '${mdfile}'")
    endif ()
    set (docdeep_program ${CMAKE_SOURCE_DIR}/src/build-scripts/docdeep.py)
    add_custom_command (OUTPUT ${mdfile}
        COMMAND /usr/bin/python ${docdeep_program} -d ${_docdeep_NAME} -s docs.css
                ${_docdeep_SOURCE} > "${CMAKE_CURRENT_BINARY_DIR}/${mdfile}"
        MAIN_DEPENDENCY ${docdeep_program}
        DEPENDS ${_docdeep_SOURCE}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "docdeep ${_docdeep_NAME}"
        )
    if (_docdeep_DOC_LIST)
        list (APPEND ${_docdeep_DOC_LIST} "${CMAKE_CURRENT_BINARY_DIR}/${mdfile}")
    endif ()
    if (_docdeep_SRC_LIST)
        list (APPEND ${_docdeep_SRC_LIST} ${_docdeep_SOURCE})
    endif ()
endmacro ()



set (all_docdeep_docs "")
set (all_docdeep_srcs "")
docdeep_generate (NAME OSLQuery
                  SOURCE ${PROJECT_SOURCE_DIR}/src/include/OSL/oslquery.h
                         ${PROJECT_SOURCE_DIR}/src/oslinfo/oslinfo.cpp
                  DOC_LIST all_docdeep_docs
                  SRC_LIST all_docdeep_srcs)
docdeep_generate (NAME docdeep
                  SOURCE ${PROJECT_SOURCE_DIR}/src/build-scripts/docdeep.py
                  DOC_LIST all_docdeep_docs
                  SRC_LIST all_docdeep_srcs)

add_custom_target (generated_docs ALL
                   DEPENDS ${all_docdeep_docs} ${all_docdeep_srcs}
                   SOURCES ${all_docdeep_srcs}
                   )

message (STATUS "All docdeep docs = ${all_docdeep_docs}")

install (FILES ${all_docdeep_docs}
        DESTINATION ${CMAKE_INSTALL_DOCDIR}
        COMPONENT documentation
        )

=== src/include/CMakeLists.txt ===
file (GLOB public_headers OSL/*.h)

if (USE_CPP VERSION_GREATER 11)
    set (OSL_BUILD_CPP14 1)
endif ()
if (USE_CPP VERSION_GREATER 17)
    set (OSL_BUILD_CPP17 1)
endif ()

message (STATUS "Create oslversion.h from oslversion.h.in")
configure_file (OSL/oslversion.h.in "${CMAKE_BINARY_DIR}/include/OSL/oslversion.h" @ONLY)
list (APPEND public_headers "${CMAKE_BINARY_DIR}/include/OSL/oslversion.h")

INSTALL ( FILES ${public_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/OSL )

set (PROJECT_PUBLIC_HEADERS ${public_headers} PARENT_SCOPE)

=== src/liboslexec/CMakeLists.txt ===
SET ( liboslexec_srcs
          shadingsys.cpp closure.cpp
          dictionary.cpp
          context.cpp instance.cpp
          loadshader.cpp master.cpp
          opcolor.cpp opmatrix.cpp opmessage.cpp
          opnoise.cpp
          opspline.cpp opstring.cpp optexture.cpp
          oslexec.cpp
          pointcloud.cpp rendservices.cpp
          constfold.cpp runtimeoptimize.cpp typespec.cpp
          lpexp.cpp lpeparse.cpp automata.cpp accum.cpp
          opclosure.cpp
          shadeimage.cpp
          backendllvm.cpp
          llvm_gen.cpp llvm_instance.cpp llvm_util.cpp
    )

# oslcomp symbols used in oslexec
if (NOT BUILDSTATIC)
    LIST(APPEND liboslexec_srcs
        ../liboslcomp/ast.cpp
        ../liboslcomp/codegen.cpp
        ../liboslcomp/oslcomp.cpp
        ../liboslcomp/symtab.cpp
        ../liboslcomp/typecheck.cpp
        )
endif ()

# oslnoise symbols used in oslexec
LIST(APPEND liboslexec_srcs
   ../liboslnoise/gabornoise.cpp
   ../liboslnoise/simplexnoise.cpp
   )

# oslquery symbols used in oslexec
if (NOT BUILDSTATIC)
    LIST(APPEND liboslexec_srcs
        ../liboslquery/oslquery.cpp
        )
endif ()

include_directories ( "${CMAKE_SOURCE_DIR}/src/liboslcomp" )

FILE ( GLOB exec_headers "*.h" )
FILE ( GLOB compiler_headers "../liboslcomp/*.h" )

FLEX_BISON ( osolex.l osogram.y oso liboslexec_srcs exec_headers )
FLEX_BISON ( ../liboslcomp/osllex.l ../liboslcomp/oslgram.y osl liboslexec_srcs compiler_headers )

SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS" )

MACRO ( LLVM_COMPILE llvm_src srclist )
    GET_FILENAME_COMPONENT ( llvmsrc_we ${llvm_src} NAME_WE )
    SET ( llvm_asm "${CMAKE_CURRENT_BINARY_DIR}/${llvmsrc_we}.s" )
    SET ( llvm_bc "${CMAKE_CURRENT_BINARY_DIR}/${llvmsrc_we}.bc" )
    SET ( llvm_bc_cpp "${CMAKE_CURRENT_BINARY_DIR}/${llvmsrc_we}.bc.cpp" )
    if (VERBOSE)
        MESSAGE (STATUS "LLVM_COMPILE in=${llvm_src}")
        MESSAGE (STATUS "LLVM_COMPILE asm=${llvm_asm}")
        MESSAGE (STATUS "LLVM_COMPILE bc=${llvm_bc}")
        MESSAGE (STATUS "LLVM_COMPILE cpp=${llvm_bc_cpp}")
    endif ()
    SET ( ${srclist} ${${srclist}} ${llvm_bc_cpp} )
    get_property (CURRENT_DEFINITIONS DIRECTORY PROPERTY COMPILE_DEFINITIONS)
    if (VERBOSE)
        message (STATUS "Current #defines are ${CURRENT_DEFINITIONS}")
    endif ()
    foreach (def ${CURRENT_DEFINITIONS})
        set (LLVM_COMPILE_FLAGS ${LLVM_COMPILE_FLAGS} "-D${def}")
    endforeach()
    set (LLVM_COMPILE_FLAGS ${LLVM_COMPILE_FLAGS} ${SIMD_COMPILE_FLAGS} ${CSTD_FLAGS} ${TOOLCHAIN_FLAGS})

    # Figure out what program we will use to make the bitcode.
    if (NOT LLVM_BC_GENERATOR)
        FIND_PROGRAM(LLVM_BC_GENERATOR NAMES "clang++" PATHS "${LLVM_DIRECTORY}/bin" NO_DEFAULT_PATH NO_CMAKE_SYSTEM_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_ENVIRONMENT_PATH NO_CMAKE_PATH)
    endif ()
    # If that didn't work, look anywhere
    if (NOT LLVM_BC_GENERATOR)
        # Wasn't in their build, look anywhere
        FIND_PROGRAM(LLVM_BC_GENERATOR NAMES clang++ llvm-g++)
    endif ()

    if (NOT LLVM_BC_GENERATOR)
        message (FATAL_ERROR "You must have a valid llvm bitcode generator (clang++) somewhere.")
    endif ()
    if (VERBOSE)
        message (STATUS "Using ${LLVM_BC_GENERATOR} to generate bitcode.")
    endif()

    # Fix specific problem I had on new Apple systems (e.g. Mavericks) with
    # LLVM/libc++ installed -- for some reason, LLVM 3.4 wasn't finding it,
    # so in that specific case, append another -I to point it in the right
    # direction.
    if (APPLE AND ${LLVM_BC_GENERATOR} MATCHES ".*clang.*")
        EXEC_PROGRAM ( "${LLVM_BC_GENERATOR}" ARGS --version OUTPUT_VARIABLE MY_CLANG_VERSION )
        string (REGEX REPLACE "clang version ([0-9][.][0-9]+).*" "\\1" MY_CLANG_VERSION "${MY_CLANG_VERSION}")
        if ((${MY_CLANG_VERSION} VERSION_GREATER "3.3")
              AND (EXISTS "/usr/lib/libc++.dylib")
              AND (EXISTS "/Library/Developer/CommandLineTools/usr/lib/c++/v1"))
            set (LLVM_COMPILE_FLAGS ${LLVM_COMPILE_FLAGS} "-I/Library/Developer/CommandLineTools/usr/lib/c++/v1")
        endif ()
    endif ()

    # Command to turn the .cpp file into LLVM assembly language .s, into
    # LLVM bitcode .bc, then back into a C++ file with the bc embedded!
    ADD_CUSTOM_COMMAND ( OUTPUT ${llvm_bc_cpp}
      COMMAND ${LLVM_BC_GENERATOR}
          ${LLVM_COMPILE_FLAGS}
          "-I${CMAKE_CURRENT_SOURCE_DIR}"
          "-I${CMAKE_SOURCE_DIR}/src/include"
          "-I${CMAKE_BINARY_DIR}/include"
          "-I${OPENIMAGEIO_INCLUDE_DIR}"
          "-I${ILMBASE_INCLUDE_DIR}"
          "-I${Boost_INCLUDE_DIRS}"
          -DOSL_COMPILING_TO_BITCODE=1
          -Wno-deprecated-register
          -O3 -fno-math-errno -S -emit-llvm -o ${llvm_asm} ${llvm_src}
      COMMAND "${LLVM_DIRECTORY}/bin/llvm-as" -f -o ${llvm_bc} ${llvm_asm}
      COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/serialize-bc.bash" ${llvm_bc} ${llvm_bc_cpp} "osl_llvm_compiled_ops"
      MAIN_DEPENDENCY ${llvm_src}
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/serialize-bc.bash"
              ${exec_headers} ${PROJECT_PUBLIC_HEADERS}
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" )

ENDMACRO ( )

# Function to compile a C++ source file to CUDA-compatible LLVM bitcode
FUNCTION ( MAKE_CUDA_BITCODE src generated_bc )
    GET_FILENAME_COMPONENT ( src_we ${src} NAME_WE )
    SET ( asm_cuda "${CMAKE_CURRENT_BINARY_DIR}/${src_we}_cuda.s" )
    SET ( bc_cuda "${CMAKE_CURRENT_BINARY_DIR}/${src_we}_cuda.bc" )

    ADD_CUSTOM_COMMAND ( OUTPUT ${bc_cuda}
        COMMAND ${LLVM_BC_GENERATOR}
            ${LLVM_COMPILE_FLAGS}
            "-I${CMAKE_CURRENT_SOURCE_DIR}"
            "-I${CMAKE_SOURCE_DIR}/src/include"
            "-I${CMAKE_BINARY_DIR}/include"
            "-I${OPENIMAGEIO_INCLUDE_DIR}"
            "-I${ILMBASE_INCLUDE_DIR}"
            "-I${Boost_INCLUDE_DIRS}"
            -D__CUDACC__ -DOSL_COMPILING_TO_BITCODE=1 -DNDEBUG -DOIIO_NO_SSE
            --language=cuda --cuda-device-only --cuda-gpu-arch=${CUDA_TARGET_ARCH}
            ${CUDA_LIB_FLAGS}
            -std=c++11 -Wno-deprecated-register
            -O3 -fno-math-errno -S -emit-llvm -o ${asm_cuda} ${src}
        COMMAND "${LLVM_DIRECTORY}/bin/llvm-as" -f -o ${bc_cuda} ${asm_cuda}
        DEPENDS ${exec_headers} ${PROJECT_PUBLIC_HEADERS} ${src}
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" )

    SET ( ${generated_bc} ${bc_cuda} PARENT_SCOPE )
ENDFUNCTION ()

MACRO ( CUDA_SHADEOPS_COMPILE srclist )
    # Add all of the "shadeops" sources that need to be compiled to LLVM bitcode for CUDA
    set ( shadeops_srcs
        llvm_ops.cpp
        opnoise.cpp
        ../liboslnoise/simplexnoise.cpp
        )

    SET ( shadeops_bc_cuda_cpp "${CMAKE_CURRENT_BINARY_DIR}/shadeops_cuda.bc.cpp" )
    SET ( linked_shadeops_bc "${CMAKE_CURRENT_BINARY_DIR}/linked_shadeops.bc" )

    LIST ( APPEND ${srclist} ${shadeops_bc_cuda_cpp} )

    FOREACH ( shadeops_src ${shadeops_srcs} )
        MAKE_CUDA_BITCODE ( ${shadeops_src} shadeops_bc )
        LIST ( APPEND shadeops_bc_list ${shadeops_bc} )
    ENDFOREACH ()

    # Link all of the individual LLVM bitcode files
    ADD_CUSTOM_COMMAND ( OUTPUT ${linked_shadeops_bc}
        COMMAND "${LLVM_DIRECTORY}/bin/llvm-link" -internalize ${shadeops_bc_list} -o ${linked_shadeops_bc}
        DEPENDS ${shadeops_bc_list} ${exec_headers} ${PROJECT_PUBLIC_HEADERS} ${shadeops_srcs}
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" )

    # Serialze the linked bitcode into a CPP file and add it to the list of liboslexec soures
    ADD_CUSTOM_COMMAND ( OUTPUT ${shadeops_bc_cuda_cpp}
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/serialize-bc.bash"
            ${linked_shadeops_bc} ${shadeops_bc_cuda_cpp} "osl_llvm_compiled_ops_cuda"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/serialize-bc.bash" ${linked_shadeops_bc}
        ${exec_headers} ${PROJECT_PUBLIC_HEADERS}
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" )
ENDMACRO ( )

if (USE_LLVM_BITCODE)
    LLVM_COMPILE ( llvm_ops.cpp liboslexec_srcs )

    # Optionally repeat the bitcode compilation with CUDA-specific options
    if (CUDA_FOUND)
        ADD_DEFINITIONS (-DOSL_LLVM_CUDA_BITCODE)
        CUDA_SHADEOPS_COMPILE ( liboslexec_srcs )
    endif ()
else ()
    # With MSVC/Mingw, we don't compile llvm_ops.cpp to LLVM bitcode, due
    # to clang being unable to compile MSVC C++ header files at this time.
    # Instead it is part of the regular build process.
    ADD_DEFINITIONS (-DOSL_LLVM_NO_BITCODE)
    SET (liboslexec_srcs ${liboslexec_srcs} llvm_ops.cpp)
endif ()

if (BUILDSTATIC)
    ADD_LIBRARY ( oslexec STATIC ${liboslexec_srcs} )
else ()
    ADD_LIBRARY ( oslexec SHARED ${liboslexec_srcs} )

    if (VERBOSE)
        message(STATUS "Setting SOVERSION to: ${SOVERSION}")
    endif ()
    set_target_properties( oslexec
                          PROPERTIES
                          VERSION ${OSL_VERSION_MAJOR}.${OSL_VERSION_MINOR}.${OSL_VERSION_PATCH}
                          SOVERSION ${SOVERSION} )
endif ()

TARGET_LINK_LIBRARIES ( oslexec
                        ${VISIBILITY_COMMAND} ${VISIBILITY_MAP_COMMAND}
                        ${OPENIMAGEIO_LIBRARIES} ${ILMBASE_LIBRARIES}
                        ${PUGIXML_LIBRARIES}
                        ${PARTIO_LIBRARIES} ${ZLIB_LIBRARIES}
                        ${Boost_LIBRARIES} ${CMAKE_DL_LIBS}
                        ${CLANG_LIBRARIES}
                        ${LLVM_LIBRARIES} ${LLVM_LDFLAGS}
                        ${LLVM_SYSTEM_LIBRARIES})
ADD_DEPENDENCIES (oslexec "${CMAKE_SOURCE_DIR}/src/build-scripts/hidesymbols.map")

install_targets (oslexec)

# Unit tests
if (OSL_BUILD_TESTS)
    add_executable (accum_test accum_test.cpp)
    target_link_libraries ( accum_test oslexec ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
    add_test (unit_accum "${CMAKE_BINARY_DIR}/src/liboslexec/accum_test")

    add_executable (dual_test dual_test.cpp)
    target_link_libraries ( dual_test ${OPENIMAGEIO_LIBRARIES} ${ILMBASE_LIBRARIES} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
    add_test (unit_dual "${CMAKE_BINARY_DIR}/src/liboslexec/dual_test")

    add_executable (llvmutil_test llvmutil_test.cpp)
    target_link_libraries ( llvmutil_test oslexec ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
    add_test (unit_llvmutil "${CMAKE_BINARY_DIR}/src/liboslexec/llvmutil_test")
endif ()

=== src/shaders/MaterialX/CMakeLists.txt ===
file (GLOB mx_shader_headers "*.h")
file (GLOB shader_source "*.mx")

# FIXME -- is this really necessary?
if (${CMAKE_GENERATOR} MATCHES "(Visual Studio.*)")
    # Work around visual studio outputting oslc.exe in a subfolder
    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/../../oslc/oslc"
        COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/../../oslc/${CMAKE_BUILD_TYPE}/oslc.exe" "${CMAKE_CURRENT_BINARY_DIR}/../oslc/"
        DEPENDS oslc)
endif ()


# Macro to compile a shader with oslc, with MX type substitution. Syntax is:
#   mx_oslc_compile (MXTEMPLATE mx_template_file
#                    SHADERNAME shader_name_no_extension_or_type
#                    TYPE substitition_type
#                 [ OTHERTYPE substitition_type ]
#                 [ DEPENDS list_of_dependencies ]
#                 [ INCLUDE_DIRS list_of_include_dirs_for_oslc ]
#                 [ DEFINES list_of_extra_definitions_for_oslc ]
#                 [ OSL_FILE optional_osl_filename_override ]
#                 [ OSO_FILE optional_oso_filename_override ]
#                 [ OSO_LIST list_to_append_oso_filename ]
#                 [ GEN_OSL_LIST list_to_append_generated_osl_filename ]
#                 )
# This is based on the oslc_compile macro found in src/shaders, but we've
# modified it to do the type substitution that MaterialX needs.
macro (mx_oslc_compile)
    cmake_parse_arguments (_shader ""
                           "MXTEMPLATE;OSL_FILE;OSO_FILE;OSO_LIST;TYPE;OTHERTYPE;SHADERNAME;GEN_OSL_LIST"
                           "DEPENDS;INCLUDE_DIRS;DEFINES" ${ARGN})
    # ^^ syntax: prefix options one-arg-keywords multi-arg-keywords args
    # set (mxfile "${CMAKE_SOURCE_DIR}/src/shaders/MaterialX/${_shader_MXTEMPLATE}")
    set (mxfile "${_shader_MXTEMPLATE}")
    set (oslfile ${_shader_OSL_FILE})
    set (osofile ${_shader_OSO_FILE})
    set (stdosl_header "${CMAKE_SOURCE_DIR}/src/shaders/stdosl.h")
    set (oslc_args -q ${_shader_DEFINES} "-I${CMAKE_CURRENT_SOURCE_DIR}")
    foreach (_incdir ${_shader_INCLUDE_DIRS})
        list (APPEND oslc_args "-I${_incdir}")
    endforeach ()
    list (APPEND oslc_args "-I${CMAKE_SOURCE_DIR}/src/shaders")
    string (TOLOWER ${_shader_TYPE} osltype)
    if (NOT _shader_OTHERTYPE)
        set (_shader_OTHERTYPE "none")
    endif ()
    if (${_shader_OTHERTYPE} STREQUAL "same")
        set (_shader_OTHERTYPE ${_shader_TYPE})
    endif ()
    if (_shader_OSL_FILE)
        set (oslfile ${_shader_OSL_FILE})
    else ()
        if (NOT ${_shader_OTHERTYPE} STREQUAL "none")
            set (oslfile "${CMAKE_CURRENT_BINARY_DIR}/${_shader_SHADERNAME}_${osltype}_${_shader_OTHERTYPE}.osl")
        else ()
            set (oslfile "${CMAKE_CURRENT_BINARY_DIR}/${_shader_SHADERNAME}_${osltype}.osl")
        endif ()
        string (REGEX REPLACE "osl$" "oso" osofile ${oslfile})
    endif ()
    if (VERBOSE)
        get_filename_component(mxfile_justname ${mxfile} NAME)
        get_filename_component(oslfile_justname ${oslfile} NAME)
        get_filename_component(osofile_justname ${osofile} NAME)
        # message (STATUS "oslc will make ${mxfile_justname} -> ${oslfile_justname} -> ${osofile_justname}")
    endif ()
    add_custom_command (OUTPUT ${osofile}
        COMMAND python "${CMAKE_CURRENT_SOURCE_DIR}/build_materialX_osl.py"
                       -s "${_shader_SHADERNAME}"
                       -m "${mxfile}"
                       -o "${oslfile}"
                       -t "${osltype}"
                       --othertypes "${_shader_OTHERTYPE}"
        COMMAND oslc ${oslc_args} "${oslfile}" -o "${osofile}"
        MAIN_DEPENDENCY ${mxfile}
        BYPRODUCTS ${oslfile}
        DEPENDS ${_shader_DEPENDS} "${stdosl_header}" oslc "${CMAKE_CURRENT_SOURCE_DIR}/build_materialX_osl.py"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "oslc ${oslfile}")
    if (_shader_OSO_LIST)
        list (APPEND ${_shader_OSO_LIST} ${osofile})
    endif ()
    if (_shader_GEN_OSL_LIST)
        list (APPEND ${_shader_GEN_OSL_LIST} ${oslfile})
    endif ()
endmacro ()


# Macro to compile a bunch of mx templates, each in several type flavors.
# Syntax is:
#   make_mx_flavors (mx_template_source_list
#                    TYPES type_list
#                    [ OTHERTYPES other_type_list ] )
macro (make_mx_flavors)
    cmake_parse_arguments (mxflav "" "" "TYPES;OTHERTYPES" ${ARGN})
    # ^^ syntax: prefix options one-arg-keywords multi-arg-keywords args
    if (NOT mxflav_OTHERTYPES)
        set (mxflav_OTHERTYPES "none")
    endif ()
    # Find out if "same" is in the list. FIXME: When cmake minimum >= 3.3,
    # we can just use ("same" IN_LIST mxflav_OTHERTYPES) in the test before
    # the 'continue' statement.
    list (FIND mxflav_OTHERTYPES "same" same_index)
    foreach (oslsrc ${mxflav_UNPARSED_ARGUMENTS})
        get_filename_component ( oslsrc_we ${oslsrc} NAME_WE )
        foreach (osltype ${mxflav_TYPES})
            foreach (oslothertype ${mxflav_OTHERTYPES})
                if (${same_index} GREATER -1 AND ${oslothertype} STREQUAL ${osltype})
                    # Trick to make sure that we don't doubly-count 'same'
                    # and the first type. As an example of when this comes
                    # up, when OTHERTYPES is 'same float' and TYPES also
                    # contains 'float'.
                    continue()
                endif ()
                if (${oslothertype} STREQUAL "same")
                    set (oslothertype ${osltype})
                endif ()
                if (${oslothertype} STREQUAL "none"
                    #OR ${oslothertype} STREQUAL ${osltype}
                    )
                    set (_shadername "${oslsrc_we}_${osltype}")
                else ()
                    set (_shadername "${oslsrc_we}_${osltype}_${oslothertype}")
                endif ()
                set (oslfile "${CMAKE_CURRENT_BINARY_DIR}/${_shadername}.osl")
                set (osofile "${CMAKE_CURRENT_BINARY_DIR}/${_shadername}.oso")
                set (mx_template_file "${CMAKE_CURRENT_SOURCE_DIR}/${oslsrc}")
                mx_oslc_compile (MXTEMPLATE ${mx_template_file}
                                 SHADERNAME ${oslsrc_we}
                                 TYPE ${osltype}
                                 OTHERTYPE ${oslothertype}
                                 OSL_FILE ${oslfile}
                                 OSO_FILE ${osofile}
                                 DEPENDS ${mx_shader_headers}
                                 INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}
                                              ${CMAKE_SOURCE_DIR}/src/shaders
                                 OSO_LIST mx_shader_objs
                                 GEN_OSL_LIST mx_shader_osls
                                 )
            endforeach ()
        endforeach ()
    endforeach ()
endmacro()


# The MaterialX shader zoo is very complicated, many of our shader templates
# need to be compiled separately for each of many types. But not all the
# same types for all shaders. Try to organize this as cleanly as possible
# below.

# MX shaders that come in flavors for all color/vector types and float.
make_mx_flavors (
            mx_absval.mx mx_acos.mx mx_asin.mx
            mx_blur.mx mx_ceil.mx mx_compare.mx
            mx_constant.mx mx_cos.mx mx_dot.mx
            mx_exp.mx mx_floor.mx mx_fractal3d.mx mx_geomattrvalue.mx
            mx_image.mx mx_ln.mx mx_mix.mx
            mx_noise2d.mx mx_noise3d.mx
            mx_ramp4.mx mx_ramplr.mx mx_ramptb.mx
            mx_sign.mx mx_sin.mx mx_splitlr.mx
            mx_splittb.mx mx_sqrt.mx
            mx_switch.mx mx_swizzle_color.mx mx_swizzle_color2.mx
            mx_swizzle_color4.mx mx_swizzle_vector.mx mx_swizzle_vector2.mx
            mx_swizzle_vector4.mx mx_tan.mx mx_tiledimage.mx
            mx_triplanarprojection.mx
    TYPES   float color color2 color4 vector vector2 vector4)

# MX shaders that are templated on two types: colorN/vectorN/float,
# versus themselves and float.
make_mx_flavors (
            mx_atan2.mx mx_clamp.mx mx_contrast.mx mx_invert.mx
            mx_max.mx mx_min.mx mx_modulo.mx mx_power.mx mx_remap.mx
            mx_smoothstep.mx
    TYPES      float color color2 color4 vector vector2 vector4
    OTHERTYPES same float)

# MX basic math operate on two elements of the same type, or type and float
make_mx_flavors (
    mx_add.mx mx_divide.mx mx_multiply.mx mx_subtract.mx
    TYPES      float color color2 color4 vector vector2 vector4 matrix33 matrix44
    OTHERTYPES same float)
make_mx_flavors (mx_add.mx      TYPES surfaceshader OTHERTYPES same)
make_mx_flavors (mx_multiply.mx TYPES surfaceshader OTHERTYPES color float)

# MX shaders that come in flavors for all color/vector types.
make_mx_flavors (
            mx_extract.mx mx_fractal3d_fa.mx
            mx_noise2d_fa.mx
            mx_noise3d_fa.mx mx_separate.mx
            mx_swizzle_float.mx
    TYPES   color color2 color4 vector vector2 vector4)

# MX shaders that come in flavors for all color types, and float
make_mx_flavors (
            mx_burn.mx mx_dodge.mx mx_geomcolor.mx mx_inside.mx
            mx_outside.mx mx_overlay.mx mx_screen.mx
    TYPES float color color2 color4)

# All the rest of the odds and ends follow:
make_mx_flavors (mx_ambientocclusion.mx TYPES float)
make_mx_flavors (mx_bitangent.mx        TYPES vector)
make_mx_flavors (mx_cellnoise2d.mx      TYPES float)
make_mx_flavors (mx_cellnoise3d.mx      TYPES float)
make_mx_flavors (mx_constant.mx         TYPES matrix44 matrix33 string filename bool int)
make_mx_flavors (mx_crossproduct.mx     TYPES vector)
make_mx_flavors (mx_determinant.mx      TYPES matrix44 matrix33)
make_mx_flavors (mx_disjointover.mx     TYPES color2 color4)
make_mx_flavors (mx_dot.mx              TYPES matrix44 matrix33 string filename bool int surfaceshader)
make_mx_flavors (mx_dotproduct.mx       TYPES vector vector2 vector4)
make_mx_flavors (mx_frame.mx            TYPES float)
make_mx_flavors (mx_geomattrvalue.mx    TYPES int bool string)
make_mx_flavors (mx_heighttonormal.mx   TYPES vector)
make_mx_flavors (mx_hsvadjust.mx        TYPES color color4)
make_mx_flavors (mx_hsvtorgb.mx         TYPES color color4)
make_mx_flavors (mx_hueshift.mx         TYPES color color4)  # DEPRECATED in MX 1.36
make_mx_flavors (mx_in.mx               TYPES color2 color4)
make_mx_flavors (mx_luminance.mx        TYPES color color4)
make_mx_flavors (mx_magnitude.mx        TYPES vector vector2 vector4)
make_mx_flavors (mx_mask.mx             TYPES color2 color4)
make_mx_flavors (mx_matte.mx            TYPES color2 color4)
make_mx_flavors (mx_mix.mx              TYPES surfaceshader)
make_mx_flavors (mx_normal.mx           TYPES vector)
make_mx_flavors (mx_normalize.mx        TYPES vector vector2 vector4)
make_mx_flavors (mx_out.mx              TYPES color2 color4)
make_mx_flavors (mx_over.mx             TYPES color2 color4)
make_mx_flavors (mx_combine_cc.mx       TYPES color4)
make_mx_flavors (mx_combine_cf.mx       TYPES color4)
make_mx_flavors (mx_combine_vf.mx       TYPES vector4)
make_mx_flavors (mx_combine_vv.mx       TYPES vector4)
make_mx_flavors (mx_position.mx         TYPES vector)
make_mx_flavors (mx_premult.mx          TYPES color color2 color4)
make_mx_flavors (mx_rgbtohsv.mx         TYPES color color4)
make_mx_flavors (mx_rotate.mx           TYPES vector vector2)
make_mx_flavors (mx_rotate2d.mx         TYPES vector2)     # DEPRECATED in MX 1.36
make_mx_flavors (mx_saturate.mx         TYPES color color4)
make_mx_flavors (mx_scale.mx            TYPES vector vector2)
make_mx_flavors (mx_tangent.mx          TYPES vector)
make_mx_flavors (mx_texcoord.mx         TYPES vector vector2)
make_mx_flavors (mx_time.mx             TYPES float)
make_mx_flavors (mx_transformpoint.mx   TYPES vector vector4)
make_mx_flavors (mx_transformvector.mx  TYPES vector vector4)
make_mx_flavors (mx_transformnormal.mx  TYPES vector vector4)

=== debian/changelog ===
openshadinglanguage (1.10.9-thomas~bionic9+9.0trisquel1) etiona-backports; urgency=medium

  * Backported from ppa

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 09 Mar 2021 00:42:07 +0000

openshadinglanguage (1.10.9-thomas~bionic9) bionic; urgency=medium

  * New upstream release. Changed OSL include headers location to follow
    blender CMake find_path hints. New oiio.

 -- Thomas Schiex <empnessty@gmail.com>  Mon, 22 Apr 2019 22:32:46 +0100

openshadinglanguage (1.10.4-thomas~bionic3) bionic; urgency=medium

  * New upstream release.

 -- Thomas Schiex <empnessty@gmail.com>  Mon, 22 Apr 2019 22:32:46 +0100

openshadinglanguage (1.9.9-thomas~bionic7) bionic; urgency=medium

  * New upstream release.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 21 Dec 2018 21:55:46 +0100

openshadinglanguage (1.8.10-thomas~bionic1) bionic; urgency=medium

  * depends on llvm 4.0.

 -- Thomas Schiex <empnessty@gmail.com>  Sun, 03 Sep 2017 16:09:11 +0200

openshadinglanguage (1.8.10-thomas~bionic0) bionic; urgency=medium

  * new upstream release.

 -- Thomas Schiex <empnessty@gmail.com>  Sun, 03 Sep 2017 15:47:40 +0200

openshadinglanguage (1.8-thomas~bionic4) bionic; urgency=medium

  * New upstream version. Compatible with recent LLVM versions.

 -- Thomas Schiex <empnessty@gmail.com>  Sat, 25 Mar 2017 01:42:32 +0100

openshadinglanguage (1.7.5-thomas~bionic0) bionic; urgency=medium

  * New upstream version

 -- Thomas Schiex <empnessty@gmail.com>  Sun, 19 Mar 2017 18:59:25 +0100

openshadinglanguage (1.7.3-0thomas~bionic0) bionic; urgency=medium

  * New upstream version.

 -- Thomas Schiex <empnessty@gmail.com>  Sat, 01 Oct 2016 03:12:31 +0200

openshadinglanguage (1.7.1-0thomas~bionic2) bionic; urgency=medium

  * Dummy change - needed for recompilation with new oiio.

 -- Thomas Schiex <empnessty@gmail.com>  Sat, 13 Feb 2016 14:27:18 +0100

openshadinglanguage (1.7.1-0thomas~bionic0) bionic; urgency=medium

  * New Blender compatible upstream version.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 12 Feb 2016 21:42:44 +0100

openshadinglanguage (1.6.8-0thomas~bionic1) bionic; urgency=medium

  * Corrected missing SOVERSION/installed files preventing shlibs:Depends to do its job.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 09 Oct 2015 23:34:20 +0200

openshadinglanguage (1.6.8-0thomas~bionic0) bionic; urgency=medium

  * New upstream version.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 20 Mar 2015 08:55:13 +0100

=== debian/control ===
Source: openshadinglanguage
Priority: extra
Maintainer: Thomas Schiex <empnessty@gmail.com>
Build-Depends: debhelper (>= 8.0.0), cmake, chrpath, python3-minimal, python-argparse,
	       flex, bison, llvm-6.0-dev (>= 3.3), clang-6.0 (>= 3.3),
	       libopenexr-dev, libopenimageio-dev, libpng-dev, libtiff5-dev,
	       libboost-filesystem-dev, libboost-regex-dev, libboost-wave-dev, libncurses5-dev,
	       libboost-system-dev, libboost-thread-dev, libtbb-dev, libilmbase-dev,
               zlib1g-dev, libbz2-dev, liblzma-dev, python2.7, python
Standards-Version: 3.9.5
Section: graphics
Homepage: https://github.com/imageworks/OpenShadingLanguage

Package: openshadinglanguage
Architecture: any
Depends: libopenshadinglanguage1.10 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - compiler
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains command line programs such as OSL compiler.

Package: libopenshadinglanguage-dev
Section: libdevel
Architecture: any
Depends: libopenshadinglanguage1.10 (= ${binary:Version}), ${misc:Depends}
Description: Small but rich language for programmable shading - development
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains header files for building programs that provides
 OSL compiler or OSL shading system.

Package: libopenshadinglanguage1.10
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - runtime
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package includes shared libraries and runtime data for
 compiling/running OSL programs.  Also includes example shader scripts.

Package: openshadinglanguage-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Small but rich language for programmable shading - document
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains a manual that describes the language specification
 of OSL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BLDDIR = debian/cmake
TMPDIR = debian/tmp
DIST := $(shell dpkg-parsechangelog | awk '/^Distribution: / {print $$2}')

EXTRA_FLAGS = -DEXTRA_OSLEXEC_LIBRARIES:STRING="tinfo"

%:
	dh $@ -Scmake -B$(BLDDIR) --parallel

override_dh_auto_configure:
	# Note: currently all tests pass on OS X but a few tests fail on Linux
	#  strictly for floating point precision reasons, not because anything
	#  is really broken.
	# Note2: graphics driver based on Gallium3D also uses LLVM, so we needs
	#  to use LLVM static library to avoid symbol conflicts.
	dh_auto_configure -- \
		-DLLVM_STATIC:BOOL=ON\
		-DLLVM_VERSION:STRING=6.0\
		-DCMAKE_CXX_FLAGS="-std=c++11"\
		-DSTOP_ON_WARNING=OFF \
		-DBUILD_TESTING:BOOL=OFF \
		-DBUILDSTATIC=OFF\
		-DOSL_BUILD_PLUGINS=OFF\
		-DUSE_SIMD=sse2 \
		-DOSL_BUILD_CPP11=1 \
		$(EXTRA_FLAGS)
	# A patch 020_fix_implicit_include changes the implicit include path to
	# stdosl.h from DESTDIR/shaders to DESTDIR/share/OSL/shaders.
	#mkdir -p $(BLDDIR)/src/share/OSL
	#ln -sf ../../shaders $(BLDDIR)/src/share/OSL

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

# override_dh_auto_install:
	# dh_auto_install
	# CMAKE_SKIP_RPATH cannot be used because it causes build failure.
	# chrpath -d $(TMPDIR)/usr/bin/* $(TMPDIR)/usr/lib/lib*.so
